# test will fail on most Unix-like systems when run as the root user
%bcond_without tests
%bcond_with kwallet
%bcond_with bdb
%bcond_without pyswig
%bcond_without ruby
%bcond_without java

# disable auto rm .la
%global __brp_remove_la_files %nil
%global jdk_path /usr/lib/jvm/java

%{!?_httpd_mmn: %{expand: %%global _httpd_mmn %%(cat %{_includedir}/httpd/.mmn 2>/dev/null || echo 0-0)}}

%define perl_vendorarch %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
%define __perl_requires %{SOURCE3}

%global svn_python_sitearch %{python3_sitearch}
%global svn_python %{__python3}
# set Python bindings path
%global swigdirs swig_pydir=%{svn_python_sitearch}/libsvn swig_pydir_extra=%{svn_python_sitearch}/svn


Summary: A Modern Concurrent Version Control System
Name: subversion
Version: 1.14.2
Release: 6%{?dist}
License: Apache-2.0
URL: https://subversion.apache.org/
Source0: https://downloads.apache.org/subversion/subversion-%{version}.tar.bz2
Source1: subversion.conf
Source3: filter-requires.sh
Source4: http://www.xsteve.at/prg/emacs/psvn.el
Source5: psvn-init.el
Source6: svnserve.service
Source7: svnserve.tmpfiles
Source8: svnserve.sysconf

Patch3000: subversion-1.12.0-linking.patch
Patch3001: subversion-1.14.0-testwarn.patch
Patch3002: subversion-1.14.2-soversion.patch
Patch3003: subversion-1.8.0-rubybind.patch
Patch3004: subversion-1.8.5-swigplWall.patch
Patch3005: subversion-1.14.1-testnomagic.patch
Patch3006: subversion-1.14.1-python-3.11-build.patch
Patch3007: subversion-1.14.2-swig-py-Fix-conditionals-by-SWIG-version-and-by-Pyth.patch
Patch3008: subversion-1.14.2-ruby32-remove-deprecated-api.patch
Patch3009: subversion-ruby-c99.patch

BuildRequires: make, autoconf, libtool, gcc, gcc-c++
BuildRequires: swig >= 1.3.24, gettext, texinfo, which
%if %{with bdb}
BuildRequires: libdb-devel >= 4.1.25
%endif
BuildRequires: python3-devel
BuildRequires: apr-devel >= 1.5.0, apr-util-devel >= 1.3.0, libuuid-devel
BuildRequires: libserf-devel >= 1.3.0, cyrus-sasl-devel
BuildRequires: sqlite-devel >= 3.4.0, file-devel, systemd-units
BuildRequires: utf8proc-devel, lz4-devel, apr-util-openssl
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
Requires: subversion-libs = %{version}-%{release}
Provides: svn = %{version}-%{release}


%description
Subversion is an open source, centralized version control system. It allows one or more users 
to collaboratively develop and maintain a hierarchy of files and directories while keeping a 
history of all changes. It stores the differences between versions, not each complete file.

%package libs
Summary: Libraries for Subversion Version Control system

%description libs
This package includes the essential shared libraries used by the Subversion version control tools.

%if %{with pyswig}
%package -n python3-subversion
Summary: Python bindings for Subversion Version Control system
BuildRequires: python3-devel py3c-devel
BuildRequires: (python3-setuptools if python3-devel >= 3.12)
Requires: subversion-libs = %{version}-%{release}

%description -n python3-subversion
This package includes the Python 3.x bindings to the Subversion libraries.
%endif

%package devel
Summary: Development package for the Subversion libraries
Requires: subversion-libs = %{version}-%{release}
Requires: apr-devel, apr-util-devel

%description devel
This package includes the libraries and head files for developers interacting with the subversion.

%package gnome
Summary: GNOME Keyring support for Subversion
Requires: subversion-libs = %{version}-%{release}
BuildRequires: dbus-devel, libsecret-devel

%description gnome
This package adds support for storing Subversion passwords in the GNOME Keyring.

%if %{with kwallet}
%package kde
Summary: KDE Wallet support for Subversion
Requires: subversion-libs = %{version}-%{release}
BuildRequires: qt5-qtbase-devel >= 5.0.0, kf5-kwallet-devel, kf5-ki18n-devel
BuildRequires: kf5-kcoreaddons-devel

%description kde
This package adds support for storing Subversion passwords in the KDE Wallet.
%endif

%package -n mod_dav_svn
Summary: Apache httpd module for Subversion server
Requires: httpd-mmn = %{_httpd_mmn}
Requires: subversion-libs = %{version}-%{release}
BuildRequires: httpd-devel >= 2.0.45

%description -n mod_dav_svn
This package allows access to a Subversion repository using HTTP, via the Apache httpd server.

%package perl
Summary: Perl bindings to the Subversion libraries
BuildRequires: perl-devel, perl-generators, perl(ExtUtils::MakeMaker)
BuildRequires: perl(Test::More), perl(ExtUtils::Embed)
Requires: subversion-libs = %{version}-%{release}

%description perl
This package includes the Perl bindings to the Subversion libraries.

%if %{with java}
%package javahl
Summary: JNI bindings to the Subversion libraries
Requires: subversion = %{version}-%{release}
BuildRequires: java-17-openjdk-devel
BuildRequires: zip unzip junit
BuildArch: noarch

%description javahl
This package includes the JNI bindings to the Subversion libraries.
%endif

%if %{with ruby}
%package ruby
Summary: Ruby bindings to the Subversion libraries
BuildRequires: ruby-devel >= 1.9.1, ruby >= 1.9.1
BuildRequires: rubygem(test-unit)
Requires: subversion-libs = %{version}-%{release}
Conflicts: ruby-libs < 1.8.2

%description ruby
This package includes the Ruby bindings to the Subversion libraries.
%endif

%package tools
Summary: Supplementary tools for Subversion
Requires: subversion-libs = %{version}-%{release}

%description tools
This package includes supplementary tools for use with Subversion.

%prep
%setup -q
%autopatch -M 3007 -p1
%patch3008 -p0
%patch3009 -p1

%build
# regenerate buildsystem to make sure the patch works.
mv build-outputs.mk build-outputs.mk.old
export PYTHON=%{svn_python}

touch build/generator/swig/*.py

# for libtoolize test...
PATH=/usr/bin:$PATH ./autogen.sh --release
# fix shebang and python executable
perl -pi -e 's|/usr/bin/env perl -w|/usr/bin/perl -w|' tools/hook-scripts/*.pl.in
perl -pi -e 's|/usr/bin/env python.*|%{svn_python}|' subversion/tests/cmdline/svneditor.py

# override weird -shrext from ruby
export svn_cv_ruby_link="%{__cc} -shared"
export svn_cv_ruby_sitedir_libsuffix=""
export svn_cv_ruby_sitedir_archsuffix=""
export svn_cv_ruby_includes="-I%{_includedir}"

export APACHE_LDFLAGS="-Wl,-z,relro,-z,now"
export CC=gcc CXX=g++ JAVA_HOME=%{jdk_path}

%configure --with-apr=%{_prefix} --with-apr-util=%{_prefix} \
        --disable-debug \
        --with-swig --with-serf=%{_prefix} \
        --with-ruby-sitedir=%{ruby_vendorarchdir} \
        --with-ruby-test-verbose=verbose \
        --with-apxs=%{_httpd_apxs} --disable-mod-activation \
        --with-apache-libexecdir=%{_httpd_moddir} \
        --disable-static --with-sasl=%{_prefix} \
        --with-libmagic=%{_prefix} \
        --with-gnome-keyring \
%if %{with java}
        --enable-javahl \
        --with-junit=%{_prefix}/share/java/junit.jar \
%endif
%if %{with kwallet}
        --with-kwallet=%{_includedir}:%{_libdir} \
%endif
%if %{with bdb}
        --with-berkeley-db \
%else
        --without-berkeley-db \
%endif
        || (cat config.log; exit 1)
%make_build all tools
%if %{with pyswig}
make swig-py swig-py-lib %{swigdirs}
%endif
make swig-pl swig-pl-lib
%if %{with ruby}
make swig-rb swig-rb-lib
%endif
%if %{with java}
# not parallel-make with javahl-javah 
make javahl
%endif

%install
%make_install
%if %{with pyswig}
make install-swig-py %{swigdirs} DESTDIR=%{buildroot}
%endif
make install-swig-pl-lib install-swig-rb DESTDIR=%{buildroot}
make pure_vendor_install -C subversion/bindings/swig/perl/native PERL_INSTALL_ROOT=%{buildroot}
%if %{with java}
make install-javahl-java install-javahl-lib javahl_javadir=%{_javadir} DESTDIR=%{buildroot}
%endif

install -m 755 -d %{buildroot}%{_sysconfdir}/subversion

mkdir -p %{buildroot}{%{_httpd_modconfdir},%{_httpd_confdir}}

%if "%{_httpd_modconfdir}" == "%{_httpd_confdir}"
# httpd <= 2.2.x
install -p -m 644 %{SOURCE1} %{buildroot}%{_httpd_confdir}
%else
sed -n /^LoadModule/p %{SOURCE1} > 10-subversion.conf
sed    /^LoadModule/d %{SOURCE1} > example.conf
touch -r %{SOURCE1} 10-subversion.conf example.conf
install -p -m 644 10-subversion.conf %{buildroot}%{_httpd_modconfdir}
%endif

# remove unused files
rm -rf %{buildroot}%{_includedir}/subversion-*/*.txt \
       %{buildroot}%{svn_python_sitearch}/*/*.{a,la}

# remove .so for libsvn_auth_{gnome,kde}, since nothing should ever link against them directly.
rm -f %{buildroot}%{_libdir}/libsvn_auth_*.so

# remove perl modules
find %{buildroot} -type f \
    -a \( -name .packlist -o \( -name '*.bs' -a -empty \) \) \
    -print0 | xargs -0 rm -f

find %{buildroot}%{_libdir}/perl5 -type f -perm 555 -print0 |
        xargs -0 chmod 755

# remove swig bindings
rm -f %{buildroot}%{_libdir}/libsvn_swig_*.{so,la,a}

# remove ruby libraries
rm -f %{buildroot}%{ruby_vendorarchdir}/svn/ext/*.*a

# remove docs
rm -rvf tools/*/*.in tools/hook-scripts/mailer/tests

# install psvn for emacs and xemacs
for f in emacs/site-lisp xemacs/site-packages/lisp; do
  install -m 755 -d %{buildroot}%{_datadir}/$f
  install -m 644 $RPM_SOURCE_DIR/psvn.el %{buildroot}%{_datadir}/$f
done

install -m 644 $RPM_SOURCE_DIR/psvn-init.el \
        %{buildroot}%{_datadir}/emacs/site-lisp

# rename authz_svn INSTALL doc
ln -f subversion/mod_authz_svn/INSTALL mod_authz_svn-INSTALL

# Trim exported dependencies to APR libraries only:
sed -i "/^dependency_libs/{
     s, -l[^ ']*, ,g;
     s, -L[^ ']*, ,g;
     s,%{_libdir}/lib[^a][^p][^r][^ ']*.la, ,g;
     }"  %{buildroot}%{_libdir}/*.la

# remove libdir in pkgconfig, avoid multilib conflicts
sed -i '/^libdir=/d' %{buildroot}%{_datadir}/pkgconfig/libsvn*.pc

# install bash completion
install -Dpm 644 tools/client-side/bash_completion \
        %{buildroot}%{_datadir}/bash-completion/completions/svn
for comp in svnadmin svndumpfilter svnlook svnsync svnversion; do
    ln -s svn \
        %{buildroot}%{_datadir}/bash-completion/completions/${comp}
done

# install svnserve bits
mkdir -p %{buildroot}%{_unitdir} \
      %{buildroot}/run/svnserve \
      %{buildroot}%{_prefix}/lib/tmpfiles.d \
      %{buildroot}%{_sysconfdir}/sysconfig

install -p -m 644 $RPM_SOURCE_DIR/svnserve.service %{buildroot}%{_unitdir}/svnserve.service
install -p -m 644 $RPM_SOURCE_DIR/svnserve.tmpfiles %{buildroot}%{_prefix}/lib/tmpfiles.d/svnserve.conf
install -p -m 644 $RPM_SOURCE_DIR/svnserve.sysconf %{buildroot}%{_sysconfdir}/sysconfig/svnserve

# install tools 
make install-tools DESTDIR=%{buildroot} toolsdir=%{_bindir}
rm -f %{buildroot}%{_bindir}/diff* %{buildroot}%{_bindir}/x509-parser

# remove spurious dependency in libserf-devel
sed -i "/^Requires.private/s, serf-1, ," %{buildroot}%{_datadir}/pkgconfig/libsvn_ra_serf.pc

# svnauthz-validate symlink
rm %{buildroot}%{_bindir}/svnauthz-validate
ln -s svnauthz %{buildroot}%{_bindir}/svnauthz-validate

for f in svn-populate-node-origins-index fsfs-access-map \
    svnauthz svnauthz-validate svnmucc svnraisetreeconflict svnbench \
    svn-mergeinfo-normalizer fsfs-stats svnmover svnconflict; do
    echo %{_bindir}/$f
    if test -f %{buildroot}%{_mandir}/man?/${f}.*; then
       echo %{_mandir}/man?/${f}.*
    fi
done | tee tools.files | sed 's/^/%%exclude /' > exclude.tools.files

%if %{with tests}
%check
export LANG=C LC_ALL=C
export LD_LIBRARY_PATH=%{buildroot}%{_libdir}
export MALLOC_PERTURB_=171 MALLOC_CHECK_=3
export LIBC_FATAL_STDERR_=1
export PYTHON=%{svn_python}
if ! make check CLEANUP=yes; then
   : Test suite failure.
   cat fails.log
   exit 1
fi
if ! make check-swig-pl check-swig-rb; then
   : Swig test failure.
   exit 1
fi
%if %{with pyswig}
if ! make check-swig-py; then
   : Python swig test failure.
   exit 1
fi
%endif
%if %{with java}
make check-javahl
%endif
%endif

%find_lang %{name}
cat %{name}.lang exclude.tools.files >> %{name}.files

%post
%systemd_post svnserve.service

%preun
%systemd_preun svnserve.service

%postun
%systemd_postun_with_restart svnserve.service

%files -f %{name}.files
%license LICENSE NOTICE
%doc BUGS COMMITTERS INSTALL README CHANGES
%doc mod_authz_svn-INSTALL
%config(noreplace) %{_sysconfdir}/sysconfig/svnserve
%dir %{_sysconfdir}/subversion
%{_unitdir}/*.service
%attr(0700,root,root) %dir /run/svnserve
%{_prefix}/lib/tmpfiles.d/svnserve.conf
%{_bindir}/*
%{_datadir}/emacs/site-lisp/*.el
%{_datadir}/xemacs/site-packages/lisp/*.el
%{_datadir}/bash-completion/
%exclude %{_mandir}/man*/*::*
%{_mandir}/man*/*

%files tools -f tools.files
%doc tools/hook-scripts tools/backup tools/examples tools/xslt
%if %{with bdb}
%doc tools/bdb
%endif

%files libs
%license LICENSE NOTICE
%{_libdir}/libsvn*.so.*
%exclude %{_libdir}/libsvn_swig_perl*
%exclude %{_libdir}/libsvn_swig_ruby*
%if %{with java}
%{_libdir}/libsvnjavahl-*.so
%endif
%if %{with kwallet}
%exclude %{_libdir}/libsvn_auth_kwallet*
%endif
%exclude %{_libdir}/libsvn_auth_gnome*

%if %{with pyswig}
%files -n python3-subversion
%{python3_sitearch}/svn
%{python3_sitearch}/libsvn
%endif

%files gnome
%{_libdir}/libsvn_auth_gnome_keyring-*.so.*

%if %{with kwallet}
%files kde
%{_libdir}/libsvn_auth_kwallet-*.so.*
%endif

%files devel
%{_includedir}/subversion-1
%{_libdir}/libsvn*.*a
%{_libdir}/libsvn*.so
%{_datadir}/pkgconfig/*.pc
%exclude %{_libdir}/libsvn_swig_perl*
%exclude %{_libdir}/libsvnjavahl-*.so

%files -n mod_dav_svn
%config(noreplace) %{_httpd_modconfdir}/*.conf
%{_libdir}/httpd/modules/mod_*.so
%if "%{_httpd_modconfdir}" != "%{_httpd_confdir}"
%doc example.conf
%endif

%files perl
%{perl_vendorarch}/auto/SVN
%{perl_vendorarch}/SVN
%{_libdir}/libsvn_swig_perl*
%{_mandir}/man*/*::*

%if %{with ruby}
%files ruby
%{_libdir}/libsvn_swig_ruby*
%{ruby_vendorarchdir}/svn
%endif

%if %{with java}
%files javahl
%{_javadir}/svn-javahl.jar
%endif

%changelog
* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.14.2-6
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.14.2-5
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Aug 17 2023 kianli@tencent.com - 1.14.2-4
- Rebuilt for apr 1.7.4 and apr-util 1.6.3

* Fri Aug 04 2023 Xiaojie Chen <jackxjchen@tencent.com> - 1.14.2-3
- Rebuilt for file 5.45

* Thu Jul 20 2023 cunshunxia <cunshunxia@tencent.com> - 1.14.2-2
- Rebuilt for httpd 2.4.57

* Mon Jul 3 2023 Wang Guodong <gordonwwang@tencent.com> - 1.14.2-1
- initial build
